// SmileElement.cpp: CSmileElement NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "textsmile.h"
#include "SmileElement.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSmileElement::CSmileElement()
{
	m_MatchCount=0;
}

CSmileElement::~CSmileElement()
{

}

void CSmileElement::SetUp(LPCTSTR pst, LPCTSTR ftr)
{
	m_Past = pst;
	m_Future = ftr;

//////////////// #  ////////////////////
	CString comp;
	while(1)
	{
		int x = m_Past.Find('#');
		if( x!=-1 )
		{
			comp += m_Past.Left(x);
			switch( m_Past[x+1] )
			{
			case '#':			//"#"
				comp += "#";
				break;
			case 'n':			//s(CR+LF)
				comp += "\r\n";
				break;
			case 'w':			//ChJ[h(porSp̈ꕶɃ}b`)
				if( x!=0 )
					comp += "#w";
				break;
			default:
				break;
			}
			m_Past = m_Past.Right( m_Past.GetLength()-x-2 );
		}
		else
		{
			comp += m_Past;
			break;
		}
	}
	m_Past = comp;

	comp.Empty();
	while(1)
	{
		int x = m_Future.Find('#');
		if( x!=-1 )
		{
			comp += m_Future.Left(x);
			switch( m_Future[x+1] )
			{
			case '#':
				comp += "#";
				break;
			case 'n':
				comp += "\r\n";
				break;
			default:
				break;
			}
			m_Future = m_Future.Right( m_Future.GetLength()-x-2 );
		}
		else
		{
			comp += m_Future;
			break;
		}
	}
	m_Future = comp;
}

//memo:::::ChJ[hdl
//porSp̂PɃ}b`(sR[hɂ̓}b`Ȃ)
//pastŎgp\
//past̓AfutureɒuƂ͕s

bool CSmileElement::MatchToPast(TCHAR* pStr)
{
	bool IsSame = true;

#define _MBCS

//p#w}b`JEg𑝂₷B
	m_MatchCount=0;

	int len = m_Past.GetLength();
	for( int i=0; i!=len; i++ )
	{
		if( pStr[i]=='\0' )
		{
			IsSame = false;
			break;
		}

		if( m_Past[i]=='#' && m_Past[i+1]=='w' )
		{
			if( pStr[i]=='\r' || pStr[i]== '\n' )
			{
				IsSame = false;
				break;
			}

			if( !_ismbblead( (UINT)pStr[i] ) )
			{
				pStr--;
				m_MatchCount++;
			}
			i++;
		}
		else
		{
			if( m_Past[i] != pStr[i] )
			{
				IsSame = false;
				break;
			}
		}
	}

#undef _MBCS

/*
	TCHAR b = pStr[m_Past.GetLength()];
	pStr[m_Past.GetLength()] = '\0';
	IsSame = ( m_Past==pStr );
	pStr[m_Past.GetLength()] = b;
*/
	return IsSame;
}
