// Smiler.h: CSmiler NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SMILER_H__EA75BB3A_7250_11D2_B313_C6322954C855__INCLUDED_)
#define AFX_SMILER_H__EA75BB3A_7250_11D2_B313_C6322954C855__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ProgDialog.h"
#include "SmileElement.h"

class CSmiler
{
public:
	CSmiler();
	virtual ~CSmiler();

	static bool CRLFFilter(CString& str,int max,CProgDialog* pDlg);
	static bool CPPFilter(CString& str,int max,CProgDialog* pDlg);
	static bool HTMLFilter(CString& str,int max,CProgDialog* pDlg);
	static bool T2HFilter(CString& str,int max,CProgDialog* pDlg);

	CString m_Zen;
	CString m_Han;

	bool HideChange(CString& str);
	bool ReverseChange(CString& str);
	bool RandDelChange(CString& str);

	void ClearChangeIndex();
	DWORD GetChangeIndexAfter(DWORD num);
	DWORD GetChangeIndexBefore(DWORD num);
	void CopyChangeIndex(CSmiler & From);

	void LoadFromReg();
	void WriteToReg();

	void Error(int num);
	void DefaultSet();

	bool LineRead( CString& str );
	bool Load( CString& filename );

	bool AddEffect( CString& str,int max,CProgDialog* pDlg );

	CString m_FileName;
	CArray<DWORD,DWORD&> m_ChangeIndex;
	CString m_Name;
	int m_Frq;
	bool m_bCRLF;
	bool m_bCPP;
	bool m_bHTML;

	CMap<char,char, CList<CSmileElement*,CSmileElement*>* , CList<CSmileElement*,CSmileElement*>* > m_Map;

protected:
	void Set(CString p,CString f);
	CString m_Separator;
};

#endif // !defined(AFX_SMILER_H__EA75BB3A_7250_11D2_B313_C6322954C855__INCLUDED_)
